---------------------------------------------------------------------------------------------------------------
--Start Activity
---------------------------------------------------------------------------------------------------------------
function Carnage:StartActivity()	
	if self.Start == nil then
		print("START! -- Carnage:StartActivity()!");
	--General settings--------------------------------------------------------------	
		self.PlayerGold = 1000000;
		Team1Module = nil
		Team2Module = nil
		Team3Module = nil
		Team4Module = nil
		for team = 0, Activity.MAXTEAMCOUNT - 1 do
			if team == 0 then
				Team1Module = self:GetTeamTech(team)
			elseif team == 1 then
				Team2Module = self:GetTeamTech(team)
			elseif team == 2 then
				Team3Module = self:GetTeamTech(team)
			elseif team == 3 then
				Team4Module = self:GetTeamTech(team)
			end
		end
		self.ModuleName = "Carnage.rte";
		
		LIB_PATH = self.ModuleName.."/Lua/"
		BASE_PATH = self.ModuleName.."/Lua/"

		--dofile(LIB_PATH.."CF_ConfigLibrary.lua");
		dofile(LIB_PATH.."CF_MissionLibrary.lua");	

	--Spawn brain and controller--------------------------------------------------------------
		--if SceneMan.Scene:GetArea("CarnageZone") ~= nil then
		--if Activity.SceneName == "Carnage Test Site" then
		if SceneMan.Scene:HasArea("CarnageZone") then
			local brain = CreateActor("Brain Case", "Base.rte")
			if brain ~= nil then
				brain.Team = 0
				brain.Pos = Vector(2280, 972)
				MovableMan:AddActor(brain);
				self:SetPlayerBrain(brain, 0)
			end	
			local actor = CreateActor("Controller", self.ModuleName)
			if actor ~= nil then
				actor.Team = 0
				actor.Pos = Vector(2280, 1212)
				MovableMan:AddActor(actor);		
				self:SwitchToActor(actor, 0, 0);
			end
		else
			self.ActivityState = Activity.EDITING
		end
		self.Start = true
	end
--timers--------------------------------------------------------------		
	self.GoldTimer = Timer()
	self.SpawnTimer = Timer()
	self.DeleteTimer = Timer()
	self.GOTOTimer = Timer()
	self.AISpawnTimer = Timer()
--tables and variables--------------------------------------------------------------
	CarnageSpawners = {}
	CarnageBeacons1 = {}
	CarnageBeacons2 = {}
	CarnageBeacons3 = {}
	CarnageBeacons4 = {}
	CarnageDropzones1 = {}
	CarnageDropzones2 = {}
	CarnageDropzones3 = {}
	CarnageDropzones4 = {}
	CarnageDelete = false	
	self.IDsCount = {}
	self.IDsCount[1] = 0
	self.IDsCount[2] = 0
	self.IDsCount[3] = 0
	self.IDsCount[4] = 0
	self.Saves = {false,false,false,false}	
	self.SavedActorsInfo = {{},{},{},{}}	
	self.SavedActorsPresets = {{},{},{},{}}
	self.SavedActorsClasses = {{},{},{},{}}
	self.OrigSpawnQueue = {0,1,2,3}
	self.TempSpawnQueue = {0,1,2,3}
	self.SpawnQueue = nil
	self.Save1 = false	--TODO
--Controller general variables--------------------------------------------------------------
	self.SelectedPage = 1
	self.SelectedValue = 1
	self.Help = false
	self.Controls = true
	self.SequentialTeams = 0
	self.NumberOfTeams = 4
	self.TempNumberOfTeams = 4
	self.RandomiseMode = 2
	self.SetAIMode = 1
	self.GoldIncome = 1	
	self.EnforceTeamLimit = true
--Controller AI and tube variables--------------------------------------------------------------
	self.ActorCheck = false
	self.ActivateTubes = false
	self.FriendlyAI = false
	self.EnemyAI = false
	self.SpawnTime = 15000	
	self.TubeSpawnTime = 5000
	self.ActorTypes = 4
	self.WeaponTypes = 2
	self.Grenades = 1
	self.Tools = 1
--Mouse variables--------------------------------------------------------------	
	self.MouseTeam = 0
	self.MouseSetAIMode = 1
	self.MouseActorTypes = 4
	self.MouseWeaponTypes = 2
	self.MouseGrenades = 1
	self.MouseTools = 1
--Reset timers--------------------------------------------------------------
	self.GoldTimer:Reset()	
	self.SpawnTimer:Reset()	
	self.DeleteTimer:Reset()
	self.GOTOTimer:Reset()
	self.AISpawnTimer:Reset()
end
-----------------------------------------------------------------------------------------
--Pause and end Activity
-----------------------------------------------------------------------------------------
function Carnage:PauseActivity(pause)
    print("PAUSE! -- Carnage:PauseActivity()!");
end

function Carnage:EndActivity()
    print("END! -- Carnage:EndActivity()!");
end
-----------------------------------------------------------------------------------------
--Update Activity
-----------------------------------------------------------------------------------------
function Carnage:UpdateActivity()
----mouse control function
	if self.SelectedPage == 3 then
		self:MouseControl()
	end
----display the option screen if controller is playercontrolled
	self:ProcessUI()
------Process Controls----------------------------
	if self.Controls == true then
	----Press B to go into editing mode---------------
		if UInputMan:KeyPressed(2) then
			--print("go into edit mode")
			if self.ActivityState == Activity.EDITING then
				--return control of actors
				for Act in MovableMan.Actors do
					if Act:IsPlayerControlled() then
						Act:GetController().InputMode = Controller.CIM_AI
					end
				end
				--open doors
				MovableMan:OpenAllDoors(false, Activity.NOTEAM)
				--resume activity

				self.ActivityState = Activity.RUNNING
			else			
				--disable actor control in edit mode
				for Act in MovableMan.Actors do
					if Act.Team == 0 then
						Act:GetController().InputMode = Controller.CIM_DISABLED
					end
				end			
				--Remove and refund the player's brains (otherwise edit mode does not work)
				for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
					if self:PlayerActive(player) and self:PlayerHuman(player) then
						local Brain = self:GetPlayerBrain(player)
						if MovableMan:IsActor(Brain) then
							self:ChangeTeamFunds(Brain:GetTotalValue(0, 1), 0)
							MovableMan:RemoveActor(Brain)
						end
					end
				end			
				--go into edit mode
				self.ActivityState = Activity.EDITING
			end
		end			
	----Press numpad keys to save actors--------------
		if UInputMan:KeyPressed(37) then
			--print("Save 0 pressed! Start Saving")
			self:SaveActors(1)
		elseif UInputMan:KeyPressed(38) then
			--print("Save 1 pressed! Start Saving")
			self:SaveActors(2)		
		elseif UInputMan:KeyPressed(39) then
			--print("Save 2 pressed! Start Saving")
			self:SaveActors(3)	
		elseif UInputMan:KeyPressed(40) then
			--print("Save 3 pressed! Start Saving")
			self:SaveActors(4)	
		end	
	----Press space to randomise----------------------------
		if UInputMan:KeyPressed(75) then
			--print("Space bar pressed! Start Randomise!")
			self:RandomiseActors()
		end	
	----press del to reset stuff and reload scripts--------------
		if UInputMan:KeyPressed(77) then	
			--print("Reload scripts")		
			--print("numpad3")
			--print(tokey("num3"))
			self:StartActivity()
			PresetMan:ReloadAllScripts();	
			CarnageDelete = true
		end
		--reset the delete switch for beacons/spawners/dropzones
		if self.DeleteTimer:IsPastRealMS(500) and CarnageDelete == true then
			CarnageDelete = false
		end	
	----press k to kill all actors that arent brains or playercontrolled--------------
		if UInputMan:KeyPressed(11) then
			for Act in MovableMan.Actors do
				if not Act:HasObjectInGroup("Brains") and not Act:IsPlayerControlled() and Act.PresetName ~= "Controller" and MovableMan:IsActor(Act) then
					Act:GibThis()
				end
			end
			-- for Particle in MovableMan.Particles do
				-- Particle.ToDelete = true
			-- end
		end
	end
----gold income-----------------------	--------------
	if self.GoldTimer:IsPastRealMS(2500) then
		if self.GoldIncome == 1 then
			self:SetTeamFunds(1000000, 0)
		elseif self.GoldIncome == 2 then
			self:SetTeamFunds(self:GetTeamFunds(0)+20, 0)
		elseif self.GoldIncome == 3 then
			self:SetTeamFunds(self:GetTeamFunds(0)+50, 0)
		elseif self.GoldIncome == 4 then
			self:SetTeamFunds(self:GetTeamFunds(0)+100, 0)
		end
		self.GoldTimer:Reset()
	end
----check actors------------------------------------	
	if self.EnforceTeamLimit == true or self.SetAIMode == 0 then
		self:ActorCheckFunction()
	end
----Spawn actors------------------------------------		
	if self.ActivateTubes == true then
		self:CloningTube()
	end
----Manage AI------------------------------------		
	if self.EnemyAI == true or self.FriendlyAI == true then
		if self.AISpawnTimer:IsPastRealMS(self.SpawnTime+(math.floor(math.random(-1000,1000)))) then
			self:SpawnReinforcements()
		end		
	end
end
-----------------------------------------------------------------------------------------
--Get Module Function
-----------------------------------------------------------------------------------------
function Carnage:GetModule(Preset)
--print("getting module")
	for i = 0, (PresetMan:GetTotalModuleCount()-1) do
		Preset.TempModule = PresetMan:GetEntityDataLocation(Preset.ClassName, Preset.PresetName, i)
		local number1, number2 = string.find(Preset.TempModule, ".rte")
		if number2 ~= nil then						
			local TempModule = string.sub(Preset.TempModule, 1, number2)
			Preset.Module = TempModule
		end
	end
	--print(Preset.Module)
	return Preset.Module
end
-----------------------------------------------------------------------------------------
--Change Teams Function
-----------------------------------------------------------------------------------------
function Carnage:ChangeTeam(NewActor)
-- print("change team function started")
	if self.RandomiseMode == 1 then
		-- print("Randomise mode = 1")
		if self.NumberOfTeams == 1 then
			if self.SequentialTeams < 4 then
				NewActor.Team = self.SequentialTeams
			else
				NewActor.Team = 0
			end
		elseif self.NumberOfTeams == 2 then
			NewActor.Team = math.floor(math.random(0,1))
		elseif self.NumberOfTeams == 3 then
			NewActor.Team = math.floor(math.random(0,2))
		elseif self.NumberOfTeams == 4 then
			NewActor.Team = math.floor(math.random(0,3))
		end
	elseif self.RandomiseMode == 2 then
		-- print("Randomise mode = 2")
		local Module1, Module2, Module3, Module4
	
		for Act in MovableMan.Actors do
			if Act:IsPlayerControlled() then
				Module1 = self:GetModule(Act)
			end
		end
		-- print("controlled actor team:")
		-- print(Module1)
		for Act in MovableMan.Actors do
			if not Act:HasObjectInGroup("Brains") and Act.PresetName ~= "Controller" and MovableMan:IsActor(Act) then
				local TempModule = self:GetModule(Act)
				if Module1 == nil and TempModule ~= Module2 and TempModule ~= Module3 and TempModule ~= Module4 then
					Module1 = TempModule
				elseif Module2 == nil and TempModule ~= Module1 and TempModule ~= Module3 and TempModule ~= Module4 then
					Module2 = TempModule
				elseif Module3 == nil and TempModule ~= Module1 and TempModule ~= Module2 and TempModule ~= Module4 then
					Module3 = TempModule
				elseif Module4 == nil and TempModule ~= Module2 and TempModule ~= Module3 and TempModule ~= Module1 then
					Module4 = TempModule
				--else 
				end
			end
		end
		-- print("modules:")
		-- print(Module1)
		-- print(Module2)
		-- print(Module3)
		-- print(Module4)
		local TempModule = self:GetModule(NewActor)
		
		if TempModule ~= nil then
			if TempModule == Module1 then
				NewActor.Team = 0
			elseif TempModule == Module2 then
				NewActor.Team = 1
			elseif TempModule == Module3 then
				NewActor.Team = 2
			elseif TempModule == Module4 then
				NewActor.Team = 3
			end
		end
	end
	-- print(NewActor.Team)
	return NewActor.Team
end
-----------------------------------------------------------------------------------------
--New Actor function
-----------------------------------------------------------------------------------------
function Carnage:NewActor(SpawnerModule)
	--print("setting up new actor")
	local NewActor = nil
	local NewCrab = nil
	if SpawnerModule ~= nil then
		--choose actor type
		if self.ActorTypes == 1 then
			NewActor = RandomAHuman("Light Infantry", SpawnerModule)
		elseif self.ActorTypes == 2 then
			NewActor = RandomAHuman("Heavy Infantry", SpawnerModule)
		elseif self.ActorTypes == 3 then	
			if self.WeaponTypes ~= 1 then
				NewCrab = RandomACrab("Mecha", SpawnerModule)
			else
				if math.random() < 0.6 then
					NewActor = RandomAHuman("Light Infantry", SpawnerModule)
				elseif math.random() < 0.8 then
					NewActor = RandomAHuman("Heavy Infantry", SpawnerModule)
				end
			end
		elseif self.ActorTypes == 4 then
			if math.random() < 0.6 then
				NewActor = RandomAHuman("Light Infantry", SpawnerModule)
			elseif math.random() < 0.8 then
				NewActor = RandomAHuman("Heavy Infantry", SpawnerModule)
			else
				if self.WeaponTypes ~= 1 then
					NewCrab = RandomACrab("Mecha", SpawnerModule)
				else
					if math.random() < 0.6 then
						NewActor = RandomAHuman("Light Infantry", SpawnerModule)
					elseif math.random() < 0.8 then
						NewActor = RandomAHuman("Heavy Infantry", SpawnerModule)
					end
				end
			end	
		elseif self.ActorTypes == 5 then
			if math.random() < 0.7 then
				NewActor = RandomAHuman("Light Infantry", SpawnerModule)
			else
				NewActor = RandomAHuman("Heavy Infantry", SpawnerModule)
			end
		end
		--choose weapons and stuff
		if NewActor then
			if not NewActor.EquippedItem then
				if self.WeaponTypes ~= 1 then
					if self.WeaponTypes == 2 then
						NewActor:AddInventoryItem(RandomHDFirearm("Primary Weapons", SpawnerModule))
					elseif self.WeaponTypes == 3 then
						NewActor:AddInventoryItem(RandomHDFirearm("Light Weapons", SpawnerModule))
					elseif self.WeaponTypes == 4 then
						NewActor:AddInventoryItem(RandomHDFirearm("Heavy Weapons", SpawnerModule))
					elseif self.WeaponTypes == 5 then
						NewActor:AddInventoryItem(RandomHDFirearm("Sniper Weapons", SpawnerModule))
					elseif self.WeaponTypes == 6 then
						NewActor:AddInventoryItem(RandomHDFirearm("Explosive Weapons", SpawnerModule))
					end
					NewActor:AddInventoryItem(RandomHDFirearm("Secondary Weapons", SpawnerModule))
				end
				if self.Grenades ~= 1 then
					if self.Grenades == 2 then
						NewActor:AddInventoryItem(RandomTDExplosive("Grenades", SpawnerModule))
					elseif self.Grenades == 3 then
						if math.random() < 0.7 then
							NewActor:AddInventoryItem(RandomTDExplosive("Grenades", SpawnerModule))
						end			
					end
				end
				if self.Tools ~= 1 then
					if self.Tools == 2 then
						NewActor:AddInventoryItem(RandomHDFirearm("Diggers", SpawnerModule))
					elseif self.Tools == 3 then
						if math.random() < 0.85 then
							NewActor:AddInventoryItem(RandomHDFirearm("Diggers", SpawnerModule))
						end
					end
				end
			end
		else
			NewActor = NewCrab
		end
		if NewActor == nil then
			NewActor = RandomAHuman("Light Infantry")
		end
		--set aimode and wp
		NewActor.AIMode = self.SetAIMode
	else
		--choose actor type
		if self.ActorTypes == 1 then
			NewActor = RandomAHuman("Light Infantry")
		elseif self.ActorTypes == 2 then
			NewActor = RandomAHuman("Heavy Infantry")
		elseif self.ActorTypes == 3 then	
			if self.WeaponTypes ~= 1 then
				NewCrab = RandomACrab("Mecha")
			else
				if math.random() < 0.6 then
					NewActor = RandomAHuman("Light Infantry")
				elseif math.random() < 0.8 then
					NewActor = RandomAHuman("Heavy Infantry")
				end
			end
		elseif self.ActorTypes == 4 then
			if math.random() < 0.6 then
				NewActor = RandomAHuman("Light Infantry")
			elseif math.random() < 0.8 then
				NewActor = RandomAHuman("Heavy Infantry")
			else
				if self.WeaponTypes ~= 1 then
					NewCrab = RandomACrab("Mecha")
				else
					if math.random() < 0.6 then
						NewActor = RandomAHuman("Light Infantry")
					elseif math.random() < 0.8 then
						NewActor = RandomAHuman("Heavy Infantry")
					end
				end
			end	
		elseif self.ActorTypes == 5 then
			if math.random() < 0.7 then
				NewActor = RandomAHuman("Light Infantry")
			else
				NewActor = RandomAHuman("Heavy Infantry")
			end
		end
		--choose weapons and stuff
		if NewActor then
			if not NewActor.EquippedItem then
				if self.WeaponTypes ~= 1 then
					if self.WeaponTypes == 2 then
						NewActor:AddInventoryItem(RandomHDFirearm("Primary Weapons"))
					elseif self.WeaponTypes == 3 then
						NewActor:AddInventoryItem(RandomHDFirearm("Light Weapons"))
					elseif self.WeaponTypes == 4 then
						NewActor:AddInventoryItem(RandomHDFirearm("Heavy Weapons"))
					elseif self.WeaponTypes == 5 then
						NewActor:AddInventoryItem(RandomHDFirearm("Sniper Weapons"))
					elseif self.WeaponTypes == 6 then
						NewActor:AddInventoryItem(RandomHDFirearm("Explosive Weapons"))
					end
					NewActor:AddInventoryItem(RandomHDFirearm("Secondary Weapons"))
				end
				if self.Grenades ~= 1 then
					if self.Grenades == 2 then
						NewActor:AddInventoryItem(RandomTDExplosive("Grenades"))
					elseif self.Grenades == 3 then
						if math.random() < 0.7 then
							NewActor:AddInventoryItem(RandomTDExplosive("Grenades"))
						end			
					end
				end
				if self.Tools ~= 1 then
					if self.Tools == 2 then
						NewActor:AddInventoryItem(RandomHDFirearm("Diggers"))
					elseif self.Tools == 3 then
						if math.random() < 0.85 then
							NewActor:AddInventoryItem(RandomHDFirearm("Diggers"))
						end
					end
				end
			end
		else
			NewActor = NewCrab
		end
		if NewActor == nil then
			NewActor = RandomAHuman("Light Infantry")
		end
		--set aimode and wp
		NewActor.AIMode = self.SetAIMode
	end
	--print("done setting up new actor")
	--print(NewActor)
	return NewActor	
end
-----------------------------------------------------------------------------------------
--Mouse New Actor function
-----------------------------------------------------------------------------------------
function Carnage:MouseNewActor(SpawnerModule)
	--print("setting up new actor")
	local NewActor = nil
	local NewCrab = nil
	if SpawnerModule ~= nil then
		--choose actor type
		if self.MouseActorTypes == 1 then
			NewActor = RandomAHuman("Light Infantry", SpawnerModule)
		elseif self.MouseActorTypes == 2 then
			NewActor = RandomAHuman("Heavy Infantry", SpawnerModule)
		elseif self.MouseActorTypes == 3 then	
			if self.MouseWeaponTypes ~= 1 then
				NewCrab = RandomACrab("Mecha", SpawnerModule)
			else
				if math.random() < 0.6 then
					NewActor = RandomAHuman("Light Infantry", SpawnerModule)
				elseif math.random() < 0.8 then
					NewActor = RandomAHuman("Heavy Infantry", SpawnerModule)
				end
			end
		elseif self.MouseActorTypes == 4 then
			if math.random() < 0.6 then
				NewActor = RandomAHuman("Light Infantry", SpawnerModule)
			elseif math.random() < 0.8 then
				NewActor = RandomAHuman("Heavy Infantry", SpawnerModule)
			else
				if self.MouseWeaponTypes ~= 1 then
					NewCrab = RandomACrab("Mecha", SpawnerModule)
				else
					if math.random() < 0.6 then
						NewActor = RandomAHuman("Light Infantry", SpawnerModule)
					elseif math.random() < 0.8 then
						NewActor = RandomAHuman("Heavy Infantry", SpawnerModule)
					end
				end
			end	
		elseif self.MouseActorTypes == 5 then
			if math.random() < 0.7 then
				NewActor = RandomAHuman("Light Infantry", SpawnerModule)
			else
				NewActor = RandomAHuman("Heavy Infantry", SpawnerModule)
			end
		end
		--choose weapons and stuff
		if NewActor then
			if not NewActor.EquippedItem then
				if self.MouseWeaponTypes ~= 1 then
					if self.MouseWeaponTypes == 2 then
						NewActor:AddInventoryItem(RandomHDFirearm("Primary Weapons", SpawnerModule))
					elseif self.MouseWeaponTypes == 3 then
						NewActor:AddInventoryItem(RandomHDFirearm("Light Weapons", SpawnerModule))
					elseif self.MouseWeaponTypes == 4 then
						NewActor:AddInventoryItem(RandomHDFirearm("Heavy Weapons", SpawnerModule))
					elseif self.MouseWeaponTypes == 5 then
						NewActor:AddInventoryItem(RandomHDFirearm("Sniper Weapons", SpawnerModule))
					elseif self.MouseWeaponTypes == 6 then
						NewActor:AddInventoryItem(RandomHDFirearm("Explosive Weapons", SpawnerModule))
					end
					NewActor:AddInventoryItem(RandomHDFirearm("Secondary Weapons", SpawnerModule))
				end
				if self.MouseGrenades ~= 1 then
					if self.MouseGrenades == 2 then
						NewActor:AddInventoryItem(RandomTDExplosive("Grenades", SpawnerModule))
					elseif self.MouseGrenades == 3 then
						if math.random() < 0.7 then
							NewActor:AddInventoryItem(RandomTDExplosive("Grenades", SpawnerModule))
						end			
					end
				end
				if self.MouseTools ~= 1 then
					if self.MouseTools == 2 then
						NewActor:AddInventoryItem(RandomHDFirearm("Diggers", SpawnerModule))
					elseif self.MouseTools == 3 then
						if math.random() < 0.85 then
							NewActor:AddInventoryItem(RandomHDFirearm("Diggers", SpawnerModule))
						end
					end
				end
			end
		else
			NewActor = NewCrab
		end
		if NewActor == nil then
			NewActor = RandomAHuman("Light Infantry")
		end
		--set aimode and wp
		NewActor.AIMode = self.MouseSetAIMode
	else
		--choose actor type
		if self.MouseActorTypes == 1 then
			NewActor = RandomAHuman("Light Infantry")
		elseif self.MouseActorTypes == 2 then
			NewActor = RandomAHuman("Heavy Infantry")
		elseif self.MouseActorTypes == 3 then	
			if self.MouseWeaponTypes ~= 1 then
				NewCrab = RandomACrab("Mecha")
			else
				if math.random() < 0.6 then
					NewActor = RandomAHuman("Light Infantry")
				elseif math.random() < 0.8 then
					NewActor = RandomAHuman("Heavy Infantry")
				end
			end
		elseif self.MouseActorTypes == 4 then
			if math.random() < 0.6 then
				NewActor = RandomAHuman("Light Infantry")
			elseif math.random() < 0.8 then
				NewActor = RandomAHuman("Heavy Infantry")
			else
				if self.MouseWeaponTypes ~= 1 then
					NewCrab = RandomACrab("Mecha")
				else
					if math.random() < 0.6 then
						NewActor = RandomAHuman("Light Infantry")
					elseif math.random() < 0.8 then
						NewActor = RandomAHuman("Heavy Infantry")
					end
				end
			end	
		elseif self.MouseActorTypes == 5 then
			if math.random() < 0.7 then
				NewActor = RandomAHuman("Light Infantry")
			else
				NewActor = RandomAHuman("Heavy Infantry")
			end
		end
		--choose weapons and stuff
		if NewActor then
			if not NewActor.EquippedItem then
				if self.MouseWeaponTypes ~= 1 then
					if self.MouseWeaponTypes == 2 then
						NewActor:AddInventoryItem(RandomHDFirearm("Primary Weapons"))
					elseif self.MouseWeaponTypes == 3 then
						NewActor:AddInventoryItem(RandomHDFirearm("Light Weapons"))
					elseif self.MouseWeaponTypes == 4 then
						NewActor:AddInventoryItem(RandomHDFirearm("Heavy Weapons"))
					elseif self.MouseWeaponTypes == 5 then
						NewActor:AddInventoryItem(RandomHDFirearm("Sniper Weapons"))
					elseif self.MouseWeaponTypes == 6 then
						NewActor:AddInventoryItem(RandomHDFirearm("Explosive Weapons"))
					end
					NewActor:AddInventoryItem(RandomHDFirearm("Secondary Weapons"))
				end
				if self.MouseGrenades ~= 1 then
					if self.MouseGrenades == 2 then
						NewActor:AddInventoryItem(RandomTDExplosive("Grenades"))
					elseif self.MouseGrenades == 3 then
						if math.random() < 0.7 then
							NewActor:AddInventoryItem(RandomTDExplosive("Grenades"))
						end			
					end
				end
				if self.MouseTools ~= 1 then
					if self.MouseTools == 2 then
						NewActor:AddInventoryItem(RandomHDFirearm("Diggers"))
					elseif self.MouseTools == 3 then
						if math.random() < 0.85 then
							NewActor:AddInventoryItem(RandomHDFirearm("Diggers"))
						end
					end
				end
			end
		else
			NewActor = NewCrab
		end
		if NewActor == nil then
			NewActor = RandomAHuman("Light Infantry")
		end
		--set aimode and wp
		NewActor.AIMode = self.MouseSetAIMode
	end
	--print("done setting up new actor")
	--print(NewActor)
	return NewActor	
end
-----------------------------------------------------------------------------------------
-- Randomise actors function
-----------------------------------------------------------------------------------------
function Carnage:RandomiseActors()
	for Act in MovableMan.Actors do
		if not Act:HasObjectInGroup("Brains") and not Act:IsPlayerControlled() and Act.PresetName ~= "Controller" and MovableMan:IsActor(Act) then						
			if Act.ClassName == "AHuman" then
				NewActor = CreateAHuman(Act.PresetName);
				
				------------------------------------------------------------------
				--Weegee's transfer inventory script START
				------------------------------------------------------------------
				local presets, classes = CF_GetInventory(Act)

				for i = 1, #presets do
				   local itm;
				   
				   if classes[i] == "HDFirearm" then
					  itm = CreateHDFirearm(presets[i])
				   elseif classes[i] == "TDExplosive" then
					  itm = CreateTDExplosive(presets[i])
				   elseif classes[i] == "HeldDevice" then
					  itm = CreateHeldDevice(presets[i])
				   end
				   
				   if itm ~= nil then
					  NewActor:AddInventoryItem(itm)
				   end
				end
				------------------------------------------------------------------
				--Weegee's transfer inventory script END
				------------------------------------------------------------------
					
				--NewActor.AIMode = Actor.AIMODE_SENTRY;
				NewActor.AIMode = self.SetAIMode
				NewActor.Pos = Act.Pos
				
				NewActor.Team = self:ChangeTeam(NewActor)
				if Act.HFlipped then
					NewActor.HFlipped  = true
				else
					NewActor.HFlipped  = false
				end
				MovableMan:AddActor(NewActor);
				Act.ToDelete = true
					
			elseif Act.ClassName == "ACrab" then
				NewActor = CreateACrab(Act.PresetName)
				
				NewActor.AIMode = self.SetAIMode
				NewActor.Pos = Act.Pos
				NewActor.Team = self:ChangeTeam(NewActor)

				MovableMan:AddActor(NewActor);
				Act.ToDelete = true
			end
			
		end
	end
	
	if self.NumberOfTeams == 1 and self.RandomiseMode == 1 then
		self.SequentialTeams = self.SequentialTeams + 1
		if self.SequentialTeams > 3 then
			self.SequentialTeams = 0
		end
	end
	
end
-----------------------------------------------------------------------------------------
--Cloning tube function
-----------------------------------------------------------------------------------------
function Carnage:CloningTube()
-----------------------------------------------------------------------------------------
--This function controls the spawning of the cloning tubes
	if self.SpawnTimer:IsPastRealMS(self.TubeSpawnTime) then
		--iterate through all the tubes
		for i = 1, #CarnageSpawners do
			--see if we need to set a module, based on the tubes' sharpness 
			local SpawnerModule = nil	
			if CarnageSpawners[i][2] == 0 then
				SpawnerModule = Team1Module
			elseif CarnageSpawners[i][2] == 1 then
				SpawnerModule = Team2Module
			elseif CarnageSpawners[i][2] == 2 then
				SpawnerModule = Team3Module
			elseif CarnageSpawners[i][2] == 3 then		
				SpawnerModule = Team4Module
			end

			local NewActor = self:NewActor(SpawnerModule)
			NewActor.Team = CarnageSpawners[i][2] 	--cloning tubes sharpness
			NewActor.Pos = CarnageSpawners[i][1]	--cloning tubes position	

			if NewActor.AIMode == 3 then
				if NewActor.Team == 0 then
					if CarnageBeacons1[1] ~= nil then
						--print("done")
						NewActor:AddAISceneWaypoint(CarnageBeacons1[math.floor(math.random(1,#CarnageBeacons1))])
					end
				elseif NewActor.Team == 1 then
					if CarnageBeacons2[1] ~= nil then
						NewActor:AddAISceneWaypoint(CarnageBeacons2[math.floor(math.random(1,#CarnageBeacons2))])
					end
				elseif NewActor.Team == 2 then
					if CarnageBeacons3[1] ~= nil then
						NewActor:AddAISceneWaypoint(CarnageBeacons3[math.floor(math.random(1,#CarnageBeacons3))])	
					end
				elseif NewActor.Team == 3 then
					if CarnageBeacons4[1] ~= nil then
						NewActor:AddAISceneWaypoint(CarnageBeacons4[math.floor(math.random(1,#CarnageBeacons4))])
					end
				end
			end	
			
			--check if enforce team limit is on
			if self.EnforceTeamLimit == true then
				if self.IDsCount[(CarnageSpawners[i][2]+1)] < ((rte.MOIDCountMax-20)/self.NumberOfTeams) then
					MovableMan:AddActor(NewActor)
				end
			else
				MovableMan:AddActor(NewActor)
			end	
			
			self.SpawnTimer:Reset()
		end
	end
end
-----------------------------------------------------------------------------------------
--Spawn reinforcements function
-----------------------------------------------------------------------------------------
function Carnage:SpawnReinforcements()
--spawn enemy AI reinforcements function
	--select a team
	if self.TempNumberOfTeams ~= self.NumberOfTeams then
		while self.TempNumberOfTeams ~= self.NumberOfTeams do
			if self.TempNumberOfTeams > self.NumberOfTeams then
				table.remove(self.TempSpawnQueue, self.TempNumberOfTeams)
				self.TempNumberOfTeams = self.TempNumberOfTeams - 1
			elseif self.TempNumberOfTeams < self.NumberOfTeams then
				--table.remove(self.TempSpawnQueue, self.TempNumberOfTeams)
				--self.TempNumberOfTeams = self.TempNumberOfTeams + 1
				self.TempSpawnQueue = {}
				local TempNumber = 0
				for i = 1, self.NumberOfTeams do
					self.TempSpawnQueue[#self.TempSpawnQueue+1] = TempNumber
					TempNumber = TempNumber + 1
				end				
				self.TempNumberOfTeams = self.NumberOfTeams
			end
		end
	end
	if self.FriendlyAI == true and self.EnemyAI == true then
		if self.TempSpawnQueue[1] == nil then
			--self.TempSpawnQueue = {0,1,2,3}
			self.TempSpawnQueue = {}
			local TempNumber = 0
			for i = 1, self.NumberOfTeams do
				self.TempSpawnQueue[#self.TempSpawnQueue+1] = TempNumber
				TempNumber = TempNumber + 1
			end
		end
		local randnum = math.floor(math.random(1,#self.TempSpawnQueue))
		self.SpawnQueue = self.TempSpawnQueue[randnum]
		table.remove(self.TempSpawnQueue, randnum);	
	elseif self.FriendlyAI == true then
		self.SpawnQueue = 0
	elseif self.EnemyAI == true then		
		if self.TempSpawnQueue[2] == nil then
			--self.TempSpawnQueue = {0,1,2,3}
			self.TempSpawnQueue = {}
			local TempNumber = 0
			for i = 1, self.NumberOfTeams do
				self.TempSpawnQueue[#self.TempSpawnQueue+1] = TempNumber
				TempNumber = TempNumber + 1
			end
		end
		local randnum = math.floor(math.random(2,#self.TempSpawnQueue))
		self.SpawnQueue = self.TempSpawnQueue[randnum]
		table.remove(self.TempSpawnQueue, randnum)
	end
	
	local Craft
	local SpawnerModule = nil
	--set module
	if self.SpawnQueue == 0 then
		if Team1Module ~= nil then
			SpawnerModule = Team1Module
		end
	elseif self.SpawnQueue == 1 then
		if Team2Module ~= nil then
			SpawnerModule = Team2Module
		end
	elseif self.SpawnQueue == 2 then
		if Team3Module ~= nil then
			SpawnerModule = Team3Module
		end
	elseif self.SpawnQueue == 3 then
		if Team4Module ~= nil then	
			SpawnerModule = Team4Module
		end
	end
	--select craft
	if SpawnerModule ~= nil then
		if math.random() < 0.6 then
			Craft = RandomACDropShip("Craft", SpawnerModule)
		else
			Craft = RandomACRocket("Craft", SpawnerModule)
		end
	else
		if math.random() < 0.6 then
			Craft = RandomACDropShip("Craft")
		else
			Craft = RandomACRocket("Craft")
		end
	end
	--craft+passengers
	if Craft then
		-- The max allowed weight of this craft plus cargo
		local craftMaxMass = Craft.MaxMass
		if craftMaxMass < 0 then
			craftMaxMass = math.huge
		elseif craftMaxMass < 1 then
			craftMaxMass = Craft.Mass + 400	-- MaxMass not defined
		end		
		--Craft.AIMode = Actor.AIMODE_GOTO	-- DropShips open doors at a high altitude in GoTo mode
		Craft.Team = self.SpawnQueue	
		if Craft.Team == 0 then
			if CarnageDropzones1[1] ~= nil then
				Craft.Pos = Vector(CarnageDropzones1[math.floor(math.random(1,#CarnageDropzones1))].X,-30)
			else
				Craft.Pos = Vector(math.floor(math.random(1,SceneMan.SceneWidth)), -30)
			end
		elseif Craft.Team == 1 then
			if CarnageDropzones2[1] ~= nil then
				Craft.Pos = Vector(CarnageDropzones2[math.floor(math.random(1,#CarnageDropzones2))].X,-30)
			else
				Craft.Pos = Vector(math.floor(math.random(1,SceneMan.SceneWidth)), -30)
			end		
		elseif Craft.Team == 2 then
			if CarnageDropzones3[1] ~= nil then
				Craft.Pos = Vector(CarnageDropzones3[math.floor(math.random(1,#CarnageDropzones3))].X,-30)
			else
				Craft.Pos = Vector(math.floor(math.random(1,SceneMan.SceneWidth)), -30)
			end		
		elseif Craft.Team == 3 then
			if CarnageDropzones4[1] ~= nil then
				Craft.Pos = Vector(CarnageDropzones4[math.floor(math.random(1,#CarnageDropzones4))].X,-30)
			else
				Craft.Pos = Vector(math.floor(math.random(1,SceneMan.SceneWidth)), -30)
			end
		end
		for _ = 1, 3 do
			--print(SpawnerModule)
			local NewActor = self:NewActor(SpawnerModule)
			NewActor.Team = self.SpawnQueue

			if NewActor.AIMode == 3 then
				if NewActor.Team == 0 then
					if CarnageBeacons1[1] ~= nil then
					--	print("done")
						NewActor:AddAISceneWaypoint(CarnageBeacons1[math.floor(math.random(1,#CarnageBeacons1))])
					end
				elseif NewActor.Team == 1 then
					if CarnageBeacons2[1] ~= nil then
						NewActor:AddAISceneWaypoint(CarnageBeacons2[math.floor(math.random(1,#CarnageBeacons2))])
					end
				elseif NewActor.Team == 2 then
					if CarnageBeacons3[1] ~= nil then
						NewActor:AddAISceneWaypoint(CarnageBeacons3[math.floor(math.random(1,#CarnageBeacons3))])	
					end
				elseif NewActor.Team == 3 then
					if CarnageBeacons4[1] ~= nil then
						NewActor:AddAISceneWaypoint(CarnageBeacons4[math.floor(math.random(1,#CarnageBeacons4))])
					end
				end
			end	
			
			if self.EnforceTeamLimit == true then
				if self.IDsCount[(self.SpawnQueue+1)] < ((rte.MOIDCountMax-20)/self.NumberOfTeams) then
					Craft:AddInventoryItem(NewActor)
				end
			else
				Craft:AddInventoryItem(NewActor)
			end

			if Craft.Mass > craftMaxMass then 
				break
			end
		end				
		-- Spawn the Craft onto the scene
		if self.EnforceTeamLimit == true then
			if self.IDsCount[(self.SpawnQueue+1)] < ((rte.MOIDCountMax-20)/self.NumberOfTeams) then
				MovableMan:AddActor(Craft)
			end
		else
			MovableMan:AddActor(Craft)
		end	
		self.AISpawnTimer:Reset()
	end
end
-----------------------------------------------------------------------------------------
--Actor check function
-----------------------------------------------------------------------------------------
function Carnage:ActorCheckFunction()
	for i = 1, 4 do
		self.IDsCount[i] = 0
		--print(self.IDsCount[i])
	end
	if self.EnforceTeamLimit == true then
		for Act in MovableMan.Actors do
			--monitor ID count
			if MovableMan:IsActor(Act) then
				self.IDsCount[(Act.Team+1)] = self.IDsCount[(Act.Team+1)] + Act.MOIDFootprint
			end		
		end
	end
	if self.SetAIMode == 0 then
		for Act in MovableMan.Actors do
			if not Act:HasObjectInGroup("Brains") and not Act:IsPlayerControlled() and MovableMan:IsActor(Act) then
				Act:GetController():SetState(Controller.MOVE_LEFT, false);
				Act:GetController():SetState(Controller.MOVE_RIGHT, false);
				Act:GetController():SetState(Controller.BODY_JUMP, false);
				Act:GetController():SetState(Controller.BODY_JUMPSTART, false);
				Act:GetController():SetState(Controller.BODY_CROUCH, false);
				Act:GetController():SetState(Controller.WEAPON_PICKUP, false);			
				Act:GetController():SetState(Controller.WEAPON_FIRE, false);	
				Act:GetController():SetState(Controller.AIM_UP, false);
				Act:GetController():SetState(Controller.AIM_DOWN, false);			
				Act:GetController():SetState(Controller.AIM_SHARP, false);
			end	
		end		
	end
end
-----------------------------------------------------------------------------------------
-- Weegee's get inventory function
-----------------------------------------------------------------------------------------
function CF_GetInventory(actor)
	--print("GetInventory")
	local inventory = {}
	local classes = {}

	if MovableMan:IsActor(actor) then
		if actor.ClassName == "AHuman" then
			local human = ToAHuman(actor);
         
			if human ~= nil then
				if human.EquippedItem ~= nil then
					inventory[#inventory + 1] = human.EquippedItem.PresetName;
					classes[#classes + 1] = human.EquippedItem.ClassName;
				end
            
				human:UnequipBGArm()
			end
		end
      
		if not actor:IsInventoryEmpty() then
			local enough = false;
			while not enough do
				local weap = nil;
         
				weap = actor:SwapNextInventory(weap, true);
            
				if weap == nil then
					enough = true;
				else
					inventory[#inventory + 1] = weap.PresetName;
					classes[#classes + 1] = weap.ClassName;
				end
			end
		end
	else
      --print("Actor: ")
      --print(actor);
	end
   
	return inventory, classes;
end
---------------------------------------------------------------------------------------------------------------
--Mehman's key function
function tokey(n)
   local KeyTable = {"a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","0","1","2","3","4","5","6","7","8","9","num0","num1","num2","num3","num4","num5","num6","num7","num8","num9",".",".",".",".",".",".",".",".",".",".",".",".",".",".",".",".",".","back","tab","enter",".",".",".",".","<",".",".",".","space","insert","del","home","end","pageup","pagedown","arrowleft","arrowright","arrowup","arrowdown"};
   local i = 1;
   while i <= 85 do
      if tostring(n):lower() == KeyTable[i] then
         return(i);
      else
         i = i+1;
      end
   end
   return 0;
end
-----------------------------------------------------------------------------------------
-- Save and load function
-----------------------------------------------------------------------------------------
function Carnage:SaveActors(SaveSlotChoice)
	if self.Saves[SaveSlotChoice] == true then
		for i = 1, #Carnage.SavedActorsInfo[SaveSlotChoice] do
			if Carnage.SavedActorsInfo[SaveSlotChoice][i][2] == "AHuman" then
				NewActor = CreateAHuman(Carnage.SavedActorsInfo[SaveSlotChoice][i][1])
				
				if Carnage.SavedActorsPresets[SaveSlotChoice][i] ~= nil then
					for i2 = 1, #Carnage.SavedActorsPresets[SaveSlotChoice][i] do
						local itm;

						if Carnage.SavedActorsClasses[SaveSlotChoice][i][i2] == "HDFirearm" then
							itm = CreateHDFirearm(Carnage.SavedActorsPresets[SaveSlotChoice][i][i2])
						elseif Carnage.SavedActorsClasses[SaveSlotChoice][i][i2] == "TDExplosive" then
							itm = CreateTDExplosive(Carnage.SavedActorsPresets[SaveSlotChoice][i][i2])
						elseif Carnage.SavedActorsClasses[SaveSlotChoice][i][i2] == "HeldDevice" then
							itm = CreateHeldDevice(Carnage.SavedActorsPresets[SaveSlotChoice][i][i2])
						end
						
						if itm ~= nil then
							NewActor:AddInventoryItem(itm)
						end
					end	
				end
			elseif Carnage.SavedActorsInfo[SaveSlotChoice][i][2] == "ACrab" then
				NewActor = CreateACrab(Carnage.SavedActorsInfo[SaveSlotChoice][i][1])
			elseif Carnage.SavedActorsInfo[SaveSlotChoice][i][2] == "ACDropShip" then
				NewActor = CreateACDropShip(Carnage.SavedActorsInfo[SaveSlotChoice][i][1])
			elseif Carnage.SavedActorsInfo[SaveSlotChoice][i][2] == "ACRocket" then
				NewActor = CreateACRocket(Carnage.SavedActorsInfo[SaveSlotChoice][i][1])
			end

			NewActor.Pos = Carnage.SavedActorsInfo[SaveSlotChoice][i][3]
			NewActor.Team = Carnage.SavedActorsInfo[SaveSlotChoice][i][4]
			NewActor.AIMode = Carnage.SetAIMode
			NewActor.HFlipped = Carnage.SavedActorsInfo[SaveSlotChoice][i][7]
			
			MovableMan:AddActor(NewActor)
		end
	else
		for Act in MovableMan.Actors do
			if not Act:HasObjectInGroup("Brains") and not Act:IsPlayerControlled() and Act.PresetName ~= "Controller" and MovableMan:IsActor(Act) and (Act.Team+1) == SaveSlotChoice then					
				local presets, classes = CF_GetInventory(Act)

				for i = 1, #presets do
					Carnage.SavedActorsPresets[(Act.Team+1)][#Carnage.SavedActorsInfo[(Act.Team+1)]+1] = presets
					Carnage.SavedActorsClasses[(Act.Team+1)][#Carnage.SavedActorsInfo[(Act.Team+1)]+1] = classes
				end
				
				Carnage.SavedActorsInfo[Act.Team+1][#Carnage.SavedActorsInfo[Act.Team+1]+1] = {Act.PresetName, Act.ClassName, Vector(Act.Pos.X, Act.Pos.Y), Act.Team, Carnage.SavedActorsPresets, Carnage.SavedActorsClasses, Act.HFlipped}
				
				self.Saves[Act.Team+1] = true
				Act.ToDelete = true
			end
		end		
	end
end
-----------------------------------------------------------------------------------------
--Mouse Control Function
-----------------------------------------------------------------------------------------
function Carnage:MouseControl()
	local act = self:GetControlledActor(0);

	if MovableMan:IsActor(act) and act.PresetName == "Controller" then
		self.Mouse = act.Pos	
		
		self.Mouse = self.Mouse + UInputMan:GetMouseMovement(0);

		-- Don't let the cursor leave the screen
		if self.Mouse.X < 0 then
			self.Mouse.X = SceneMan.Scene.Width - 1
		end
		
		if self.Mouse.Y < 10 then
			self.Mouse.Y = 10;
		end

		if self.Mouse.X > SceneMan.Scene.Width then
			self.Mouse.X = 0;
		end
		
		if self.Mouse.Y > SceneMan.Scene.Height - 10 then
			self.Mouse.Y = SceneMan.Scene.Height - 10;
		end
		
		-- Move cursor actor
		act.Pos = self.Mouse;

		-- Process clicking
		if UInputMan:MouseButtonPressed(0) then
			local SpawnerModule = nil	
			if self.MouseTeam == 0 then
				SpawnerModule = Team1Module
			elseif self.MouseTeam == 1 then
				SpawnerModule = Team2Module
			elseif self.MouseTeam == 2 then
				SpawnerModule = Team3Module
			elseif self.MouseTeam == 3 then		
				SpawnerModule = Team4Module
			end

			self:MouseNewActor(SpawnerModule)
			
			local NewActor = self:MouseNewActor(SpawnerModule)
			NewActor.Team = self.MouseTeam
			NewActor.Pos = act.Pos

			if NewActor.AIMode == 3 then
				if NewActor.Team == 0 then
					if CarnageBeacons1[1] ~= nil then
						--print("done")
						NewActor:AddAISceneWaypoint(CarnageBeacons1[math.floor(math.random(1,#CarnageBeacons1))])
					end
				elseif NewActor.Team == 1 then
					if CarnageBeacons2[1] ~= nil then
						NewActor:AddAISceneWaypoint(CarnageBeacons2[math.floor(math.random(1,#CarnageBeacons2))])
					end
				elseif NewActor.Team == 2 then
					if CarnageBeacons3[1] ~= nil then
						NewActor:AddAISceneWaypoint(CarnageBeacons3[math.floor(math.random(1,#CarnageBeacons3))])	
					end
				elseif NewActor.Team == 3 then
					if CarnageBeacons4[1] ~= nil then
						NewActor:AddAISceneWaypoint(CarnageBeacons4[math.floor(math.random(1,#CarnageBeacons4))])
					end
				end
			end	
			
			print(NewActor)
			--check if enforce team limit is on
			if self.EnforceTeamLimit == true then
				if self.IDsCount[(self.MouseTeam+1)] < ((rte.MOIDCountMax-20)/self.NumberOfTeams) then
					MovableMan:AddActor(NewActor)
				end
			else
				MovableMan:AddActor(NewActor)
			end	
		end		
	end
end
-----------------------------------------------------------------------------------------
--modified Weegee's process UI function
-----------------------------------------------------------------------------------------
function Carnage:ProcessUI()
	local act = self:GetControlledActor(0);
	
	-- Process controls
	if MovableMan:IsActor(act) and act.PresetName == "Controller" then
		local cont = act:GetController()
		
		-- Switch to prev preset
		if cont:IsState(Controller.PRESS_UP) then
			self.SelectedValue = self.SelectedValue - 1
			if self.SelectedValue < 1 then
				if self.SelectedPage == 2 then	
					self.SelectedValue = 10
				else
					self.SelectedValue = 7
				end
			end
		end
		-- Switch to next preset
		if cont:IsState(Controller.PRESS_DOWN) then
			self.SelectedValue = self.SelectedValue + 1
			if self.SelectedPage == 2 then
				if self.SelectedValue > 10 then
					self.SelectedValue = 1
				end
			else
				if self.SelectedValue > 7 then
					self.SelectedValue = 1
				end
			end
		end

		if cont:IsState(Controller.PRESS_LEFT) or cont:IsState(Controller.PRESS_RIGHT) then
			--Page 1-4
			if self.SelectedValue == 1 then
				if cont:IsState(Controller.PRESS_LEFT) then
					self.SelectedPage = self.SelectedPage - 1
					if self.SelectedPage == 0 then
						self.SelectedPage = 3
					end
				end			
				if cont:IsState(Controller.PRESS_RIGHT) then
					self.SelectedPage = self.SelectedPage + 1
					if self.SelectedPage == 4 then
						self.SelectedPage = 1
					end
				end
			end			
			if self.SelectedPage == 1 then	
				--controls 
				if self.SelectedValue == 2 then
					if self.Controls == false then
						self.Controls = true
					else
						self.Controls = false
					end
				end						
				--number of teams 1-4
				if self.SelectedValue == 3 then
					if cont:IsState(Controller.PRESS_LEFT) then
						self.NumberOfTeams = self.NumberOfTeams - 1
						if self.NumberOfTeams == 0 then
							self.NumberOfTeams = 4
						end
					end
				
					if cont:IsState(Controller.PRESS_RIGHT) then
						self.NumberOfTeams = self.NumberOfTeams + 1
						if self.NumberOfTeams == 5 then
							self.NumberOfTeams = 1
						end
					end
				end
				--randomise mode: completely random, random by module
				if self.SelectedValue == 4 then
					if cont:IsState(Controller.PRESS_LEFT) then
						self.RandomiseMode = self.RandomiseMode - 1
						if self.RandomiseMode == 0 then
							self.RandomiseMode = 2
						end
					end
				
					if cont:IsState(Controller.PRESS_RIGHT) then
						self.RandomiseMode = self.RandomiseMode + 1
						if self.RandomiseMode == 3 then
							self.RandomiseMode = 1
						end
					end
				end
				--ai mode: sentry, brainhunt, goto, patrol
				if self.SelectedValue == 5 then
					if cont:IsState(Controller.PRESS_LEFT) then
						self.SetAIMode = self.SetAIMode - 1
						if self.SetAIMode == -1 then
							self.SetAIMode = 5
						end
					end
				
					if cont:IsState(Controller.PRESS_RIGHT) then
						self.SetAIMode = self.SetAIMode + 1
						if self.SetAIMode == 6 then
							self.SetAIMode = 0
						end
					end
				end
				--Gold options: infinite, low, average, high income, no income
				if self.SelectedValue == 6 then
					if cont:IsState(Controller.PRESS_LEFT) then
						self:SetTeamFunds(0, 0)
						self.GoldIncome = self.GoldIncome - 1
						if self.GoldIncome == 0 then
							self.GoldIncome = 5
						end
						if self.GoldIncome == 5 then
							self:SetTeamFunds(0, 0)
						end
					end
				
					if cont:IsState(Controller.PRESS_RIGHT) then
						self:SetTeamFunds(0, 0)
						self.GoldIncome = self.GoldIncome + 1
						if self.GoldIncome == 6 then
							self.GoldIncome = 1
						end
						if self.GoldIncome == 5 then
							self:SetTeamFunds(0, 0)
						end
					end
				end
				--Team Limit----------
				if self.SelectedValue == 7 then
					if self.EnforceTeamLimit == false then
						self.EnforceTeamLimit = true
					else
						self.EnforceTeamLimit = false
					end		
				end			
			elseif self.SelectedPage == 2 then
				--enemy ai----------
				if self.SelectedValue == 2 then
					if self.EnemyAI == false then
						self.EnemyAI = true
					else
						self.EnemyAI = false
					end		
				end	
				--friendly ai----------
				if self.SelectedValue == 3 then
					if self.FriendlyAI == false then
						self.FriendlyAI = true
					else
						self.FriendlyAI = false
					end		
				end	
				--cloning tubes----------
				if self.SelectedValue == 4 then
					if self.ActivateTubes == false then
						self.ActivateTubes = true
					else
						self.ActivateTubes = false
					end		
				end		
				--actor types
				if self.SelectedValue == 5 then
					if cont:IsState(Controller.PRESS_LEFT) then
						self.ActorTypes = self.ActorTypes - 1
						if self.ActorTypes == 0 then
							self.ActorTypes = 5
						end
					end
				
					if cont:IsState(Controller.PRESS_RIGHT) then
						self.ActorTypes = self.ActorTypes + 1
						if self.ActorTypes == 6 then
							self.ActorTypes = 1
						end
					end
				end	
				--weapon types
				if self.SelectedValue == 6 then
					if cont:IsState(Controller.PRESS_LEFT) then
						self.WeaponTypes = self.WeaponTypes - 1
						if self.WeaponTypes == 0 then
							self.WeaponTypes = 7
						end
					end
				
					if cont:IsState(Controller.PRESS_RIGHT) then
						self.WeaponTypes = self.WeaponTypes + 1
						if self.WeaponTypes == 8 then
							self.WeaponTypes = 1
						end
					end
				end		
				--grenades
				if self.SelectedValue == 7 then
					if cont:IsState(Controller.PRESS_LEFT) then
						self.Grenades = self.Grenades - 1
						if self.Grenades == 0 then
							self.Grenades = 3
						end
					end
				
					if cont:IsState(Controller.PRESS_RIGHT) then
						self.Grenades = self.Grenades + 1
						if self.Grenades == 4 then
							self.Grenades = 1
						end
					end
				end
				--tools
				if self.SelectedValue == 8 then
					if cont:IsState(Controller.PRESS_LEFT) then
						self.Tools = self.Tools - 1
						if self.Tools == 0 then
							self.Tools = 3
						end
					end
				
					if cont:IsState(Controller.PRESS_RIGHT) then
						self.Tools = self.Tools + 1
						if self.Tools == 4 then
							self.Tools = 1
						end
					end
				end				
				--Spawntime
				if self.SelectedValue == 9 then
					if cont:IsState(Controller.PRESS_LEFT) then
						self.SpawnTime = self.SpawnTime - 500
						if self.SpawnTime == 1500 then
							self.SpawnTime = 30000
						end
					end
				
					if cont:IsState(Controller.PRESS_RIGHT) then
						self.SpawnTime = self.SpawnTime + 500
						if self.SpawnTime == 30500 then
							self.SpawnTime = 2000
						end
					end
				end	
				--Tube Spawntime
				if self.SelectedValue == 10 then
					if cont:IsState(Controller.PRESS_LEFT) then
						self.TubeSpawnTime = self.TubeSpawnTime - 500
						if self.TubeSpawnTime == 1500 then
							self.TubeSpawnTime = 30000
						end
					end
				
					if cont:IsState(Controller.PRESS_RIGHT) then
						self.TubeSpawnTime = self.TubeSpawnTime + 500
						if self.TubeSpawnTime == 30500 then
							self.TubeSpawnTime = 2000
						end
					end
				end		
			elseif self.SelectedPage == 3 then
				--teams 1-4
				if self.SelectedValue == 2 then
					if cont:IsState(Controller.PRESS_LEFT) then
						self.MouseTeam = self.MouseTeam - 1
						if self.MouseTeam == -1 then
							self.MouseTeam = 3
						end
					end
				
					if cont:IsState(Controller.PRESS_RIGHT) then
						self.MouseTeam = self.MouseTeam + 1
						if self.MouseTeam == 4 then
							self.MouseTeam = 0
						end
					end
				end	
				--ai mode: sentry, brainhunt, goto, patrol
				if self.SelectedValue == 3 then
					if cont:IsState(Controller.PRESS_LEFT) then
						self.MouseSetAIMode = self.MouseSetAIMode - 1
						if self.MouseSetAIMode == 0 then
							self.MouseSetAIMode = 5
						end
					end
				
					if cont:IsState(Controller.PRESS_RIGHT) then
						self.MouseSetAIMode = self.MouseSetAIMode + 1
						if self.MouseSetAIMode == 6 then
							self.MouseSetAIMode = 1
						end
					end
				end			
				--actor types
				if self.SelectedValue == 4 then
					if cont:IsState(Controller.PRESS_LEFT) then
						self.MouseActorTypes = self.MouseActorTypes - 1
						if self.MouseActorTypes == 0 then
							self.MouseActorTypes = 5
						end
					end
				
					if cont:IsState(Controller.PRESS_RIGHT) then
						self.MouseActorTypes = self.MouseActorTypes + 1
						if self.MouseActorTypes == 6 then
							self.MouseActorTypes = 1
						end
					end
				end	
				--weapon types
				if self.SelectedValue == 5 then
					if cont:IsState(Controller.PRESS_LEFT) then
						self.MouseWeaponTypes = self.MouseWeaponTypes - 1
						if self.MouseWeaponTypes == 0 then
							self.MouseWeaponTypes = 7
						end
					end
				
					if cont:IsState(Controller.PRESS_RIGHT) then
						self.MouseWeaponTypes = self.MouseWeaponTypes + 1
						if self.MouseWeaponTypes == 8 then
							self.MouseWeaponTypes = 1
						end
					end
				end		
				--grenades
				if self.SelectedValue == 6 then
					if cont:IsState(Controller.PRESS_LEFT) then
						self.MouseGrenades = self.MouseGrenades - 1
						if self.MouseGrenades == 0 then
							self.MouseGrenades = 3
						end
					end
				
					if cont:IsState(Controller.PRESS_RIGHT) then
						self.MouseGrenades = self.MouseGrenades + 1
						if self.MouseGrenades == 4 then
							self.MouseGrenades = 1
						end
					end
				end
				--tools
				if self.SelectedValue == 7 then
					if cont:IsState(Controller.PRESS_LEFT) then
						self.MouseTools = self.MouseTools - 1
						if self.MouseTools == 0 then
							self.MouseTools = 3
						end
					end
				
					if cont:IsState(Controller.PRESS_RIGHT) then
						self.MouseTools = self.MouseTools + 1
						if self.MouseTools == 4 then
							self.MouseTools = 1
						end
					end
				end	
			end
		end	

		CF_DrawString(">>>>", act.Pos + Vector(-70 , (-110-(self.SelectedValue * -10))), 200, 200);

		CF_DrawString("Page:", act.Pos + Vector(-50 , -100), 200, 200);
		if self.SelectedPage == 1 then
			--start page 1--
			CF_DrawString("1: General Options", act.Pos + Vector(-20 , -100), 200, 200);
			--controls--
			CF_DrawString("Controls:", act.Pos + Vector(-50 , -90), 200, 200);
			if self.Controls == true then
				CF_DrawString("On", act.Pos + Vector(62 , -90), 200, 200);				
			else
				CF_DrawString("Off", act.Pos + Vector(62 , -90), 200, 200);				
			end		
			--number of teams--
			CF_DrawString("Number of teams:", act.Pos + Vector(-50 , -80), 200, 200);
			CF_DrawString(tostring(self.NumberOfTeams), act.Pos + Vector(62 , -80), 200, 200);	
			--randomise mode--
			CF_DrawString("Randomise Mode:", act.Pos + Vector(-50 , -70), 200, 200);
			if self.RandomiseMode == 1 then
				CF_DrawString("Completely Random", act.Pos + Vector(62 , -70), 200, 200);
			elseif self.RandomiseMode == 2 then
				CF_DrawString("Random by Tech", act.Pos + Vector(62 , -70), 200, 200);
			end	
			--AI mode--
			CF_DrawString("AI Mode:", act.Pos + Vector(-50 , -60), 200, 200);
			if self.SetAIMode == 0 then
				CF_DrawString("No AI", act.Pos + Vector(62 , -60), 200, 200);
			elseif self.SetAIMode == 1 then
				CF_DrawString("Sentry Mode", act.Pos + Vector(62 , -60), 200, 200);
			elseif self.SetAIMode == 2 then
				CF_DrawString("Patrol Mode", act.Pos + Vector(62 , -60), 200, 200);
			elseif self.SetAIMode == 3 then
				CF_DrawString("Goto Mode", act.Pos + Vector(62 , -60), 200, 200);
			elseif self.SetAIMode == 4 then
				CF_DrawString("BrainHunt Mode", act.Pos + Vector(62 , -60), 200, 200);
			elseif self.SetAIMode == 5 then
				CF_DrawString("GoldDig Mode", act.Pos + Vector(62 , -60), 200, 200);
			end			
			--gold mode--
			CF_DrawString("Gold Mode:", act.Pos + Vector(-50 , -50), 200, 200);
			if self.GoldIncome == 1 then
				CF_DrawString("Infinite", act.Pos + Vector(62 , -50), 200, 200);
			elseif self.GoldIncome == 2 then
				CF_DrawString("Low income", act.Pos + Vector(62 , -50), 200, 200);
			elseif self.GoldIncome == 3 then
				CF_DrawString("Average income", act.Pos + Vector(62 , -50), 200, 200);
			elseif self.GoldIncome == 4 then
				CF_DrawString("High income", act.Pos + Vector(62 , -50), 200, 200);
			elseif self.GoldIncome == 5 then
				CF_DrawString("Zero income", act.Pos + Vector(62 , -50), 200, 200);
			end	
			--team limit--
			if self.EnforceTeamLimit == true then
				CF_DrawString("Enforce Team Limit: On", act.Pos + Vector(-50 , -40), 200, 200);
			elseif self.EnforceTeamLimit == false then
				CF_DrawString("Enforce Team Limit: Off", act.Pos + Vector(-50 , -40), 200, 200);
			end	
			--module selection--
			-- CF_DrawString("Module Selection:", act.Pos + Vector(-50 , -20), 200, 200);
			-- if self.ActorCheck == true then
				-- CF_DrawString("On", act.Pos + Vector(62 , -10), 200, 200);
			-- elseif self.ActorCheck == false then
				-- CF_DrawString("Off", act.Pos + Vector(62 , -10), 200, 200);
			-- end			
			--end page 1--
		elseif self.SelectedPage == 2 then
			--start page 2--
			CF_DrawString("2: AI Options", act.Pos + Vector(-20 , -100), 200, 200);
			--activate enemy AI--
			CF_DrawString("Enemy AI:", act.Pos + Vector(-50 , -90), 200, 200);
			if self.EnemyAI == true then
				CF_DrawString("On", act.Pos + Vector(62 , -90), 200, 200);
			elseif self.EnemyAI == false then
				CF_DrawString("Off", act.Pos + Vector(62 , -90), 200, 200);
			end
			--activate friendly AI--
			CF_DrawString("Friendly AI:", act.Pos + Vector(-50 , -80), 200, 200);
			if self.FriendlyAI == true then
				CF_DrawString("On", act.Pos + Vector(62 , -80), 200, 200);
			elseif self.FriendlyAI == false then
				CF_DrawString("Off", act.Pos + Vector(62 , -80), 200, 200);
			end
			--activate tubes--
			CF_DrawString("Cloning Tubes:", act.Pos + Vector(-50 , -70), 200, 200)
			if self.ActivateTubes == true then
				CF_DrawString("On", act.Pos + Vector(62 , -70), 200, 200);
			elseif self.ActivateTubes == false then
				CF_DrawString("Off", act.Pos + Vector(62 , -70), 200, 200);
			end
			--actor types--
			CF_DrawString("Actor Types:", act.Pos + Vector(-50 , -60), 200, 200);
			if self.ActorTypes == 1 then
				CF_DrawString("Light Infantry", act.Pos + Vector(62 , -60), 200, 200);
			elseif self.ActorTypes == 2 then
				CF_DrawString("Heavy Infantry", act.Pos + Vector(62 , -60), 200, 200);
			elseif self.ActorTypes == 3 then
				CF_DrawString("Crabs", act.Pos + Vector(62 , -60), 200, 200);
			elseif self.ActorTypes == 4 then
				CF_DrawString("Mixed", act.Pos + Vector(62 , -60), 200, 200);	
			elseif self.ActorTypes == 5 then
				CF_DrawString("Bipedals Only", act.Pos + Vector(62 , -60), 200, 200);				
			end
			--weapon types--
			CF_DrawString("Weapon Types:", act.Pos + Vector(-50 , -50), 200, 200)	
			if self.WeaponTypes == 1 then
				CF_DrawString("Unarmed", act.Pos + Vector(62 , -50), 200, 200)	
			elseif self.WeaponTypes == 2 then
				CF_DrawString("Random", act.Pos + Vector(62 , -50), 200, 200)
			elseif self.WeaponTypes == 3 then
				CF_DrawString("Light Weapons", act.Pos + Vector(62 , -50), 200, 200)
			elseif self.WeaponTypes == 4 then
				CF_DrawString("Heavy Weapons", act.Pos + Vector(62 , -50), 200, 200)		
			elseif self.WeaponTypes == 5 then
				CF_DrawString("Sniper Weapons", act.Pos + Vector(62 , -50), 200, 200)	
			elseif self.WeaponTypes == 6 then
				CF_DrawString("Explosive Weapons", act.Pos + Vector(62 , -50), 200, 200)
			elseif self.WeaponTypes == 7 then
				CF_DrawString("Secondary Weapons only", act.Pos + Vector(62 , -50), 200, 200)			
			end
			--Grenades--
			CF_DrawString("Grenades:", act.Pos + Vector(-50 , -40), 200, 200)	
			if self.Grenades == 1 then
				CF_DrawString("No", act.Pos + Vector(62 , -40), 200, 200)	
			elseif self.Grenades == 2 then
				CF_DrawString("Yes", act.Pos + Vector(62 , -40), 200, 200)
			elseif self.Grenades == 3 then
				CF_DrawString("Random", act.Pos + Vector(62 , -40), 200, 200)				
			end
			--Tools--
			CF_DrawString("Tools:", act.Pos + Vector(-50 , -30), 200, 200)	
			if self.Tools == 1 then
				CF_DrawString("No", act.Pos + Vector(62 , -30), 200, 200)	
			elseif self.Tools == 2 then
				CF_DrawString("Yes", act.Pos + Vector(62 , -30), 200, 200)
			elseif self.Tools == 3 then
				CF_DrawString("Random", act.Pos + Vector(62 , -30), 200, 200)				
			end	
			--Spawntime--
			CF_DrawString("Spawntime:", act.Pos + Vector(-50 , -20), 200, 200)	
			CF_DrawString(tostring(self.SpawnTime), act.Pos + Vector(62, -20), 200, 200)
			--Tube Spawntime--
			CF_DrawString("Tube Spawntime:", act.Pos + Vector(-50 , -10), 200, 200)	
			CF_DrawString(tostring(self.TubeSpawnTime), act.Pos + Vector(62, -10), 200, 200)			
			--end page 2--
		elseif self.SelectedPage == 3 then
			--start page 3--
			CF_DrawString("3: Mouse Controls", act.Pos + Vector(-20 , -100), 200, 200)
			--team
			CF_DrawString("Team:", act.Pos + Vector(-50 , -90), 200, 200);
			if self.MouseTeam == 0 then
				CF_DrawString("Red", act.Pos + Vector(62 , -90), 200, 200)
			elseif self.MouseTeam == 1 then
				CF_DrawString("Green", act.Pos + Vector(62 , -90), 200, 200)
			elseif self.MouseTeam == 2 then
				CF_DrawString("Blue", act.Pos + Vector(62 , -90), 200, 200)
			elseif self.MouseTeam == 3 then
				CF_DrawString("Yellow", act.Pos + Vector(62 , -90), 200, 200)
			end
			--ai mode
			CF_DrawString("AI Mode:", act.Pos + Vector(-50 , -80), 200, 200);
			if self.MouseSetAIMode == 0 then
				CF_DrawString("No AI", act.Pos + Vector(62 , -80), 200, 200);
			elseif self.MouseSetAIMode == 1 then
				CF_DrawString("Sentry Mode", act.Pos + Vector(62 , -80), 200, 200);
			elseif self.MouseSetAIMode == 2 then
				CF_DrawString("Patrol Mode", act.Pos + Vector(62 , -80), 200, 200);
			elseif self.MouseSetAIMode == 3 then
				CF_DrawString("Goto Mode", act.Pos + Vector(62 , -80), 200, 200);
			elseif self.MouseSetAIMode == 4 then
				CF_DrawString("BrainHunt Mode", act.Pos + Vector(62 , -80), 200, 200);
			elseif self.MouseSetAIMode == 5 then
				CF_DrawString("GoldDig Mode", act.Pos + Vector(62 , -80), 200, 200);
			end	
			--actor types--
			CF_DrawString("Actor Types:", act.Pos + Vector(-50 , -70), 200, 200);
			if self.MouseActorTypes == 1 then
				CF_DrawString("Light Infantry", act.Pos + Vector(62 , -70), 200, 200);
			elseif self.MouseActorTypes == 2 then
				CF_DrawString("Heavy Infantry", act.Pos + Vector(62 , -70), 200, 200);
			elseif self.MouseActorTypes == 3 then
				CF_DrawString("Crabs", act.Pos + Vector(62 , -70), 200, 200);
			elseif self.MouseActorTypes == 4 then
				CF_DrawString("Mixed", act.Pos + Vector(62 , -70), 200, 200);	
			elseif self.MouseActorTypes == 5 then
				CF_DrawString("Bipedals Only", act.Pos + Vector(62 , -70), 200, 200);				
			end
			--weapon types--
			CF_DrawString("Weapon Types:", act.Pos + Vector(-50 , -60), 200, 200)	
			if self.MouseWeaponTypes == 1 then
				CF_DrawString("Unarmed", act.Pos + Vector(62 , -60), 200, 200)	
			elseif self.MouseWeaponTypes == 2 then
				CF_DrawString("Random", act.Pos + Vector(62 , -60), 200, 200)
			elseif self.MouseWeaponTypes == 3 then
				CF_DrawString("Light Weapons", act.Pos + Vector(62 , -60), 200, 200)
			elseif self.MouseWeaponTypes == 4 then
				CF_DrawString("Heavy Weapons", act.Pos + Vector(62 , -60), 200, 200)		
			elseif self.MouseWeaponTypes == 5 then
				CF_DrawString("Sniper Weapons", act.Pos + Vector(62 , -60), 200, 200)	
			elseif self.MouseWeaponTypes == 6 then
				CF_DrawString("Explosive Weapons", act.Pos + Vector(62 , -60), 200, 200)
			elseif self.MouseWeaponTypes == 7 then
				CF_DrawString("Secondary Weapons only", act.Pos + Vector(62 , -60), 200, 200)			
			end
			--Grenades--
			CF_DrawString("Grenades:", act.Pos + Vector(-50 , -50), 200, 200)	
			if self.MouseGrenades == 1 then
				CF_DrawString("No", act.Pos + Vector(62 , -50), 200, 200)	
			elseif self.MouseGrenades == 2 then
				CF_DrawString("Yes", act.Pos + Vector(62 , -50), 200, 200)
			elseif self.MouseGrenades == 3 then
				CF_DrawString("Random", act.Pos + Vector(62 , -50), 200, 200)				
			end
			--Tools--
			CF_DrawString("Tools:", act.Pos + Vector(-50 , -40), 200, 200)	
			if self.MouseTools == 1 then
				CF_DrawString("No", act.Pos + Vector(62 , -40), 200, 200)	
			elseif self.MouseTools == 2 then
				CF_DrawString("Yes", act.Pos + Vector(62 , -40), 200, 200)
			elseif self.MouseTools == 3 then
				CF_DrawString("Random", act.Pos + Vector(62 , -40), 200, 200)				
			end
			--end page 3--
		elseif self.SelectedPage == 4 then
			--start page 4--
			CF_DrawString("4: test", act.Pos + Vector(-20 , -100), 200, 200)
			--end page 4--
		end
	end
end
-----------------------------------------------------------------------------------------
--End Activity
-----------------------------------------------------------------------------------------