function Create(self)
	self.SavedActorsPresets = {}
	self.SavedActorsClasses = {}
	self.SavedActorsInfo = {}
end

function Update(self)
	if self.ToDelete then
		if self.ID == self.RootID then
			for Act in MovableMan.Actors do
				local dist = SceneMan:ShortestDistance(self.Pos,Act.Pos,SceneMan.SceneWrapsX).Magnitude;
				if dist < 75 then
					self.ActorFound = 1
					if not Act:HasObjectInGroup("Brains") and not Act:IsPlayerControlled() and Act.PresetName ~= "Controller" and MovableMan:IsActor(Act) and (Act.ClassName == "AHuman" or Act.ClassName == "ACrab") then					
						
						if Act.ClassName == "AHuman" then
							NewActor = CreateAHuman(Act.PresetName);
							
							------------------------------------------------------------------
							--Weegee's transfer inventory script START
							------------------------------------------------------------------
							local presets, classes = CF_GetInventory(Act)

							for i = 1, #presets do
							   local itm;
							   
							   if classes[i] == "HDFirearm" then
								  itm = CreateHDFirearm(presets[i])
							   elseif classes[i] == "TDExplosive" then
								  itm = CreateTDExplosive(presets[i])
							   elseif classes[i] == "HeldDevice" then
								  itm = CreateHeldDevice(presets[i])
							   end
							   
							   if itm ~= nil then
								  NewActor:AddInventoryItem(itm)
							   end
							end
							------------------------------------------------------------------
							--Weegee's transfer inventory script END
							------------------------------------------------------------------
								
							--NewActor.AIMode = Actor.AIMODE_SENTRY;
							NewActor.AIMode = Act.AIMode
							NewActor.Pos = Act.Pos
							
							NewActor.Team = self.Sharpness
							if Act.HFlipped then
								NewActor.HFlipped  = true
							else
								NewActor.HFlipped  = false
							end
							MovableMan:AddActor(NewActor);
							Act.ToDelete = true
								
						elseif Act.ClassName == "ACrab" then
							NewActor = CreateACrab(Act.PresetName)
							
							NewActor.AIMode = Act.AIMode
							NewActor.Pos = Act.Pos
							NewActor.Team = self.Sharpness

							MovableMan:AddActor(NewActor);
							Act.ToDelete = true
						end
						
					end
				end
			end	
			if self.ActorFound == 1 then
				self:GibThis()
			end
		end	
	end
end
-----------------------------------------------------------------------------------------
function CF_GetInventory(actor)
   --print("GetInventory")
   local inventory = {}
   local classes = {}

   if MovableMan:IsActor(actor) then
      if actor.ClassName == "AHuman" then
         local human = ToAHuman(actor);
         
         if human ~= nil then
            if human.EquippedItem ~= nil then
               inventory[#inventory + 1] = human.EquippedItem.PresetName;
               classes[#classes + 1] = human.EquippedItem.ClassName;
            end
            
            human:UnequipBGArm()
         end
      end
      
      if not actor:IsInventoryEmpty() then
         local enough = false;
         while not enough do
            local weap = nil;
         
            weap = actor:SwapNextInventory(weap, true);
            
            if weap == nil then
               enough = true;
            else
               inventory[#inventory + 1] = weap.PresetName;
               classes[#classes + 1] = weap.ClassName;
            end
         end
      end
   else
      --print("Actor: ")
      --print(actor);
   end
   
   return inventory, classes;
end
---------------------------------------------------------------------------------------------------------------	